package io.onedev.server.search.entity.issue;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.From;
import javax.persistence.criteria.Predicate;

import io.onedev.commons.utils.ExplicitException;
import io.onedev.server.model.Issue;
import io.onedev.server.util.criteria.Criteria;

public class CurrentIssueCriteria extends Criteria<Issue> {

	private static final long serialVersionUID = 1L;
	
	@Override
	public Predicate getPredicate(CriteriaQuery<?> query, From<Issue, Issue> from, CriteriaBuilder builder) {
		if (Issue.get() != null)
			return builder.equal(from, Issue.get());
		else
			throw new ExplicitException("No issue in query context");
	}

	@Override
	public boolean matches(Issue issue) {
		if (Issue.get() != null)
			return Issue.get().equals(issue);
		else
			throw new ExplicitException("No issue in query context");
	}

	@Override
	public String toStringWithoutParens() {
		return IssueQuery.getRuleName(IssueQueryLexer.CurrentIssue);
	}

}
